﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using EdgeStatz.Controls.Calender;

namespace EdgeStatz.Controls
{
    public partial class CalenderControl : UserControl
    {
        private DateTime selected_Date;
        private CalenderMode display_Mode = CalenderMode.WorkWeek;
        CalenderTaskCollection tasks = new CalenderTaskCollection();

        /// <summary>
        /// Gets or sets the collection of contacts displayed by the calender control
        /// </summary>
        public CalenderTaskCollection Tasks
        {
            set { tasks = value; }
            get { return tasks; }
        }
        /// <summary>
        /// Gets or sets the displaye mode of the calender control.
        /// </summary>
        public CalenderMode DisplayMode
        {
            set { display_Mode = value; }
            get { return display_Mode; }
        }
        /// <summary>
        /// Gets or sets the selected date of the calender control.
        /// </summary>
        public DateTime Selected_Date
        {
            set { selected_Date = value; }
            get { return selected_Date; }
        }
        /// <summary>
        /// Gets the current date and time.
        /// </summary>
        public DateTime Today
        {
            get { return DateTime.Now; }
        }

        public CalenderControl()
        {
            InitializeComponent();
        }
    }

    public enum CalenderMode
    {
        Day, WorkWeek, FullWeek, Month, Year
    }
}
